//  25-09-2006
#include "cpu.h"
#include "spi.h"
#include "at45Const.h"





void SET_FLASH_CS (unsigned char chip_sel)
{
	(PORTB|=(1<<0));
}
 
void CLR_FLASH_CS (unsigned char chip_sel)
{
	(PORTB&=~(1<<0));
}
 
void InitSPI(void)
/*
  SPI 
*/
{
	unsigned char i;


	SPCR=0;
 	PORTB |= (1<<0);
	DDRB &= ~(1<<3);
 	DDRB |= ((1<<1)|(1<<2)|(1<<0));
	i=0x50|SPI_SPEED;
	SPCR=i;
	SPSR=0x01;
	SET_FLASH_CS(0);
	SET_FLASH_CS(1);
}
 
void SPIOut(struct TSPIData *spi_data)
{
	unsigned char operation;
	unsigned char TxCnt;
	unsigned short DataCount;
	unsigned char *DataPtr;
	unsigned char *TxArray;
	unsigned int i;
	unsigned char B, tx_rx_flag;
	unsigned char count;
	unsigned char check_counter = 0;
	unsigned char Set_CS;

	TxArray=spi_data->TxArrayPtr;
	TxCnt=spi_data->TxCnt;
	DataPtr=spi_data->DataPtr;
	DataCount=spi_data->DataCount;	
	operation=spi_data->Operation;
	Set_CS=spi_data->SetChipSelect;

	if (TxCnt==0) {
		SET_FLASH_CS(spi_data->SetChipSelect);
	}
	else {
		CLR_FLASH_CS(spi_data->SetChipSelect);
		i=0; 
		//   (,)
		while (i!=TxCnt) {
			SPDR=*TxArray++;
			i++;
			while ((SPSR&(1<<SPIF))==0) ;
		}
		// transmit data
		if ((operation==SEND_SPI)&&(DataCount!=0)) {
			i=0;
			tx_rx_flag=1;
			B=*DataPtr++;
			count = (DataCount > 255) ? (255) : ((unsigned char)DataCount);
			DataCount-=count;
			do {
				SPDR=B;
				B=*DataPtr++;
				if (--count==0) {
					if (DataCount) {
						count = (DataCount > 255) ? (255) : ((unsigned char)DataCount);
						DataCount-=count;
					}
					else {
						tx_rx_flag = 0;
					}
				}
				else {
					while ((SPSR&(1<<SPIF))==0) ;
				}

			} while (tx_rx_flag);
			while ((SPSR&(1<<SPIF))==0) ;
		}
		
		// receive data
		if ((operation==RECEIVE_SPI)&&(DataCount!=0)) {
			SPDR=0xFF;
			tx_rx_flag=1;
			count = (DataCount > 255) ? (255) : ((unsigned char)DataCount);
			DataCount-=count;
			if (DataCount==0) check_counter=1;
			do {				
				while ((SPSR&(1<<SPIF))==0) ;
				B = SPDR;
				if (check_counter) {
					if (count!=1)
						SPDR = 0xFF;
				}
				else 
					SPDR=0xFF;
				*DataPtr++=B;
				if (--count==0) {
					if (DataCount) {
						count = (DataCount > 255) ? (255) : ((unsigned char)DataCount);
						DataCount-=count;
						if (DataCount==0) check_counter = 1;
					}
					else
						tx_rx_flag = 0;
				}

			} while (tx_rx_flag);
		}			
		if (Set_CS)
			SET_FLASH_CS(spi_data->SetChipSelect);
	}
}
 
